using System;
using System.IO;
using System.Windows.Forms;
using System.Runtime.InteropServices;

public class ClipboardLinks : Form 
{
	private System.Windows.Forms.Button button2;
	private System.Windows.Forms.Button button1;
	private System.Windows.Forms.TextBox textBox1;
	private System.Windows.Forms.NotifyIcon notifyIcon1;
	private System.ComponentModel.IContainer components;
	private System.Windows.Forms.SaveFileDialog saveFileDialog1;

	IntPtr ClipboardViewer;
	System.Drawing.Size s_OldSize;
	StreamWriter SW;
	string sFile="";

	public ClipboardLinks()
	{
		// Zainicializowanie wygenerowanych komponentow
		this.InitializeComponent();
		// Dolanczanie do listy nasluchiwaczy schowka (jak kolwiek sprosnie by to nie brzmialo)
		// ClipboardViewer to nastepny nasluchiwac na liscie
		ClipboardViewer = SetClipboardViewer(this.Handle);
	}
	protected override void WndProc(ref Message m)
	{
		switch (m.Msg)
		{
			case ((int)0x0308):
				//Schowek dostal nowa informacje
				IDataObject iData = new DataObject();
				try 
				{
					iData = Clipboard.GetDataObject();
				}
				catch (Exception e) 
				{
					MessageBox.Show("Pobranie zawartosci schowka nie powiodlo sie z powodu stanu w jakim zanjduje sie watek tego procesu\r\n"
						+"wiadomosc:"+e.Message+"\r\n"
						+"zrodlo:"+e.Source+"\r\n"
						+"metoda:"+e.TargetSite+"\r\n"
						+"stos:"+e.StackTrace);
					return;
				}

				if (iData!=null && iData.GetDataPresent(DataFormats.Text))
				{
					string s = (string)iData.GetData(DataFormats.Text);
					if(s.StartsWith("http")) 
					{
						this.textBox1.Text+="<a href="+s+">link</a>\r\n";
					}
					//MessageBox.Show(s);
				}
				// Przeslanie informacji o zmianie do nastepnego nasluchiwacza
				SendMessage(ClipboardViewer, m.Msg, m.WParam, m.LParam);
				break;
			case ((int)0x030D):
				//Jakies okno przestalo nasluchiwac zmian w schowku
				//Jesli to my mielismy z nim kontak, przypisujemy nowe powiazanie
				if (m.WParam == ClipboardViewer)
				{
					ClipboardViewer = m.LParam;
				}
				else
				{
					// ... w przeciwnym wypadku przesylamy wiadomosc dalej
					SendMessage(ClipboardViewer, m.Msg, m.WParam, m.LParam);
				}
				break;
			default:
				// Pozostale wiadomosci
				base.WndProc(ref m);
				break;
		}

	}
	// Zewnetrzna funkcja
	// Metoda dodajaca nowego nasluchiwacza
	[DllImport("user32.dll", CharSet=CharSet.Auto)]
	public static extern IntPtr SetClipboardViewer(IntPtr hWnd);
	// Zewnetrzna funkcja
	// Metoda modyfikujace liste nasluchiwaczy
	[DllImport("user32.dll", CharSet=CharSet.Auto)]
	public static extern bool ChangeClipboardChain(
		IntPtr hWndRemove,  // handle to window to remove
		IntPtr hWndNewNext  // handle to next window
		);
	// Zewnetrzna funkcja
	// Metoda wysylajaca wiadomosc do wybranego nasluchiwacza
	[DllImport("user32.dll", CharSet=CharSet.Auto)]
	public static extern int SendMessage(IntPtr hwnd, int wMsg, IntPtr wParam, IntPtr lParam);
	// Punkt wejsciowy
	public static void Main(string[] args) 
	{
		ClipboardLinks app = new ClipboardLinks();
		Application.Run(app);
	}

	// Kod wygenerowany przez VS
	private void InitializeComponent()
	{
		this.components = new System.ComponentModel.Container();
		System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ClipboardLinks));
		this.button2 = new System.Windows.Forms.Button();
		this.button1 = new System.Windows.Forms.Button();
		this.textBox1 = new System.Windows.Forms.TextBox();
		this.notifyIcon1 = new System.Windows.Forms.NotifyIcon(this.components);
		this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
		this.SuspendLayout();
		// 
		// button2
		// 
		this.button2.Location = new System.Drawing.Point(120, 224);
		this.button2.Name = "button2";
		this.button2.Size = new System.Drawing.Size(96, 23);
		this.button2.TabIndex = 2;
		this.button2.Text = "Zapisz";
		this.button2.Click += new System.EventHandler(this.button2_Click);
		// 
		// button1
		// 
		this.button1.Location = new System.Drawing.Point(8, 224);
		this.button1.Name = "button1";
		this.button1.Size = new System.Drawing.Size(88, 23);
		this.button1.TabIndex = 1;
		this.button1.Text = "Zapisz jako...";
		this.button1.Click += new System.EventHandler(this.button1_Click);
		// 
		// textBox1
		// 
		this.textBox1.AcceptsReturn = true;
		this.textBox1.AutoSize = false;
		this.textBox1.Location = new System.Drawing.Point(0, 0);
		this.textBox1.Multiline = true;
		this.textBox1.Name = "textBox1";
		this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
		this.textBox1.Size = new System.Drawing.Size(224, 216);
		this.textBox1.TabIndex = 3;
		this.textBox1.Text = "";
		this.textBox1.WordWrap = false;
		// 
		// notifyIcon1
		// 
		this.notifyIcon1.Icon = ((System.Drawing.Icon)(resources.GetObject("notifyIcon1.Icon")));
		this.notifyIcon1.Text = "ClipboardLinks";
		this.notifyIcon1.Click += new System.EventHandler(this.notifyIcon1_Click);
		// 
		// saveFileDialog1
		// 
		this.saveFileDialog1.DefaultExt = "txt";
		this.saveFileDialog1.FileName = "links";
		this.saveFileDialog1.Filter = "Text files(*.txt)|*.txt";
		// 
		// ClipboardLinks
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(224, 253);
		this.Controls.Add(this.textBox1);
		this.Controls.Add(this.button2);
		this.Controls.Add(this.button1);
		this.Name = "ClipboardLinks";
		this.Text = "ClipboardLinks";
		this.Resize += new System.EventHandler(this.ClipboardLinks_Resize);
		this.Closed += new System.EventHandler(this.ClipboardLinks_Closed);
		this.ResumeLayout(false);

	}

	// Zdarzenie przycisku
	private void button1_Click(object sender, System.EventArgs e)
	{
		if (saveFileDialog1.ShowDialog() != DialogResult.Cancel) 
		{
			this.sFile = saveFileDialog1.FileName;
			SW = File.CreateText(this.sFile);
			SW.Write(this.textBox1.Text);
			SW.Close();
		}
		else 
		{
			this.sFile = "";
		}
	}
	// Rozgloszenie naszego odejscia od nasluchu
	private void ClipboardLinks_Closed(object sender, System.EventArgs e)
	{
		ChangeClipboardChain(this.Handle, ClipboardViewer);
	}

	private void ClipboardLinks_Resize(object sender, System.EventArgs e)
	{
		this.s_OldSize=this.Size;
		this.textBox1.Size=new System.Drawing.Size(this.Size.Width-7,this.textBox1.Size.Height);
		if (FormWindowState.Minimized == this.WindowState) 
		{
			this.notifyIcon1.Visible=true;
			this.Hide();
		}
	}

	private void notifyIcon1_Click(object sender, System.EventArgs e)
	{
		this.notifyIcon1.Visible=false;
		this.Show();
		this.WindowState=FormWindowState.Normal;
		this.Size=this.s_OldSize;
	}

	private void button2_Click(object sender, System.EventArgs e)
	{
		if(this.sFile.Equals("")) 
		{
			this.button1_Click(sender,e);
		}
		else 
		{
			SW = File.CreateText(this.sFile);
			SW.Write(this.textBox1.Text);
			SW.Close();
		}
	}
}